
#ifndef CONTRAST_H
#define  CONTRAST_H


#include <arrayTools/Array.h>

#include <arrayTools/namespace_header.h>


namespace _ARRAYTOOLS_NAMESPACE
{

extern array<u_char>&	Contrast(array<u_char>& I, double w);
extern array<int>&	    Contrast(array<int>& I,    double w, double norm = 127);
extern array<float>&	Contrast(array<float>& I,  double w, double norm = 127);
extern array<double>&	Contrast(array<double>& I, double w, double norm = 127);
extern array<u_char>&	Contrast(array<u_char>& I, double w, double alpha);
extern array<u_char>&	fastContrast(array<u_char>& I, int w);

}



#endif
