//
// Binary operations macros 
//

#define COMMA ,
#define NOF

#define ARITH1_OPER_MASK(f, op)               \
      for(int h = 0; h < deltaXX; h++)  {     \
          for(int k = 0; k < deltaYY; k++)  { \
            *wpointer++ = f(*rpointer1 op     \
                             o2);             \
             rpointer1++;                     \
          }                                   \
          wpointer  += hm - deltaYY;          \
          rpointer1 += h1 - deltaYY;          \
      }									      

#define ARITH2_OPER_MASK(f, op)               \
      for(int h = 0; h < deltaXX; h++)  {     \
          for(int k = 0; k < deltaYY; k++)  { \
            *wpointer++ = f(o1 op             \
                           *rpointer2);       \
             rpointer2++;                     \
          }                                   \
          wpointer  += hm - deltaYY;          \
          rpointer2 += h2 - deltaYY;          \
      }									      


#define ARITH_OPER_MASK(f, op)                \
      for(int h = 0; h < deltaXX; h++)  {     \
          for(int k = 0; k < deltaYY; k++)  { \
            *wpointer++ = f(*rpointer1 op     \
                            *rpointer2);      \
             rpointer1++;                     \
             rpointer2++;                     \
          }                                   \
          wpointer  += hm - deltaYY;          \
          rpointer1 += h1 - deltaYY;          \
          rpointer2 += h2 - deltaYY;          \
      }

#define ARITH1_OPER_FILT(f, op)               \
      for(int h = 0; h < deltaXX; h++)  {     \
          for(int k = 0; k < deltaYY; k++)  { \
            if(get_pixel(filter,              \
                         YY[i] + k,           \
                         XX[j] + h))          \
             {                                \
                *wpointer++ = f(*rpointer1 op \
                                 o2);         \
                 rpointer1++;                 \
             }                                \
            else {                            \
                *wpointer++ = of;             \
                 rpointer1++;                 \
            }                                 \
          }                                   \
          wpointer  += initY;                 \
          rpointer1 += h1 - deltaYY;          \
      }

#define ARITH2_OPER_FILT(f, op)               \
      for(int h = 0; h < deltaXX; h++)  {     \
          for(int k = 0; k < deltaYY; k++)  { \
            if(get_pixel(filter,              \
                         YY[i] + k,           \
                         XX[j] + h))          \
             {                                \
                *wpointer++ = f(*rpointer2 op \
                                 o1);         \
                 rpointer2++;                 \
             }                                \
            else {                            \
                *wpointer++ = of;             \
                 rpointer2++;                 \
            }                                 \
          }                                   \
          wpointer  += initY;                 \
          rpointer2 += h2 - deltaYY;          \
      }

#define ARITH_OPER_FILT(f, op)                \
      for(int h = 0; h < deltaXX; h++)  {     \
          for(int k = 0; k < deltaYY; k++)  { \
            if(get_pixel(filter,              \
                         YY[i] + k,           \
                         XX[j] + h))          \
             {                                \
                *wpointer++ = f(*rpointer2 op \
                                *rpointer1);  \
                 rpointer1++;                 \
                 rpointer2++;                 \
             }                                \
            else {                            \
                *wpointer++ = of;             \
                 rpointer1++;                 \
            }                                 \
          }                                   \
          wpointer  += initY;                 \
          rpointer1 += h1 - deltaYY;          \
          rpointer2 += h2 - deltaYY;          \
      }



