#ifndef TIFFIO_H
#define TIFFIO_H

#include <arrayTools/Array.h>
#include <arrayTools/namespace_header.h>


namespace _ARRAYTOOLS_NAMESPACE
{
  int ReadTiffRGBA(array<unsigned char>& R, 
				   array<unsigned char>& G,
				   array<unsigned char>& B,
				   array<unsigned char>& A,
				   char *          filename);

  int ReadTiffFloatRGB(array<float>& R, 
					   array<float>& G,
					   array<float>& B,
					   char *  filename);

  int ReadTiffFloatRGBA(array<float>& R, 
						array<float>& G,
						array<float>& B,
						array<float>& A,
						char *  filename);

  int WriteTiffRGBA(array<unsigned char>& R, 
					array<unsigned char>& G,
					array<unsigned char>& B,
					array<unsigned char>& A,
					char *          filename);

  int TiffTest();
}


#endif
