require(TeMa)
require(AnImAl)

sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages/")
#
# Read a sample image
#
face1 <- as.animage(getChannels(read.pnm(file.path(sampleimages,
"sampleFace_01.pgm"))))

x0 <- 26
y0 <- 87
dx <- 58
dy <- 36

eye <- ia.get(f, animask(x0,y0,dx, dy)

for(y in ia.ymin(face1):(ia.ymax(face1)-dy)) {
  for(x in ia.xmin(face1):(ia.xmax(face1)-dx)) {
    w <- ia.get(face1, animask(x, y, dx, dy))
    ia.show(w)
  }
}
