#ifndef JPGIO_ERROR_H
#define JPGIO_ERROR_H

#include <arrayTools/namespace_header.h>
#include <arrayTools/global.h>
#include <stdio.h>
#include <setjmp.h>

#define  HAVE_BOOLEAN

extern "C" {
#include <jpeglib.h>
#include <jerror.h>
}




namespace _ARRAYTOOLS_NAMESPACE {


  struct at_error_mgr 
  {
    struct jpeg_error_mgr pub;	/* "public" fields */
    jmp_buf setjmp_buffer;	/* for return to caller */
  };

  typedef struct at_error_mgr * at_error_ptr;

  void at_error_exit (j_common_ptr cinfo);

}

#endif
