#
#
#
tm.robustEstimates <- function(X, mode)
{
  if(!(is.array(X)) || !(is.real(X)))
    stop("X must be a REAL array");

  if(!(is.character(mode)))
    stop("mode must be a string");
 
  if(!((substring(mode,1,1) == "p") ||
       (substring(mode,1,1) == "M") ||
       (substring(mode,1,1) == "O")))
    stop("mode must be [p|M|O]");
  
  res <- .Call("tmRobustEstimates",
               X,
               mode,
               PACKAGE="TeMa")

  res
}
